/*
 * Name: Widget Debugger
 * Developer: Vinyl
 * Date: 12/18/2015
 */
define(function () {

    var g_widgetApi;

    var generateParameterElements = function() {

      var parametersElement = document.getElementById("widgetApiParameters");
      while (parametersElement.children.length > 0) {
        parametersElement.removeChild(parametersElement.children[0]);
      }

      var paramNames = g_widgetApi.getParameterNames();
      paramNames.sort();

      var ul = document.createElement('ul');
      parametersElement.appendChild(ul);

      for (var i = 0; i < paramNames.length; ++i) {
        var name = paramNames[i];
        var value = g_widgetApi.getParameter(name);
        var text = name +": " + value;

        var li = document.createElement('li');
        ul.appendChild(li);
        li.innerHTML = text;
      }
    };

    var dataChanged = function(eventRow) {
      generateParameterElements();
    }

    var install = function (holderElement, widgetApi) {

        g_widgetApi = widgetApi;

        var localeElement = document.getElementById("widgetApiLocale");
        localeElement.textContent = "Locale: " + g_widgetApi.getLocale();

        var languageElement = document.getElementById("widgetApiLanguage");
        languageElement.textContent = "Language: " + g_widgetApi.getLanguage();

        generateParameterElements();

        g_widgetApi.setDataChangeCallback(dataChanged);
    };

    var uninstall = function(holderElement, wigetApi) {
      g_widgetApi = null;
    };

    return {
        callbacks: {
            events: {
                // adding and removing
                install: install,
                uninstall: uninstall
            }
        }
    };
});
